import fs from "fs-extra";
import yaml from "yaml";
import u from "@yanick/updeep-remeda";

const handler = async (config) => {
  if (!config.change)
    throw new Error("can't add a change without a description");

  const entry = {
    desc: config.change.join(" "),
  };

  if (config.ticket) entry.ticket = config.ticket;
  if (config.type) entry.type = config.type;

  config.consola.start(`adding '${entry.desc}' to the changelog`);

  await config.add_to_next(entry);

  config.consola.success("done!");
};

export default {
  command: "add [change...]",
  desc: "add a change to the NEXT release",
  builder: (yargs) => {
    yargs
      .string("ticket")
      .describe("ticket", "ticket associated with the change")
      .string("type")
      .describe("type", "type of change");
  },
  handler,
};
