import { test, expect, vi } from "vitest";
import cut from "./cut.js";

test("add a new NEXT", async () => {
  const changelog = {
    releases: [{ version: "NEXT", changes: [] }, { version: "1.0.0" }],
  };

  const noop = () => {};
  const config = {
    consola: {
      start: noop,
      success: noop,
    },
    changelog: () => changelog,
    save_changelog: noop,
  };

  await cut.handler(config);

  expect(changelog.releases[0].version).toBe("NEXT");
  expect(changelog.releases).toHaveLength(3);
});
