import { test, expect, vi } from "vitest";
import gather from "./git-gather.js";

test("no changes detected", async () => {
  const changelog = {
    releases: [{ version: "NEXT", changes: [] }, { version: "1.0.0" }],
  };

  const noop = () => {};
  const config = {
    consola: {
      start: noop,
      success: vi.fn(),
    },
    changelog: () => changelog,
    next_release: () => ({
      changes: [],
    }),
    latest_version: () => ({ version: "1.2.3" }),
    git: () => ({
      log: () => ({ all: [] }),
    }),
  };

  await gather.handler(config);

  expect(config.consola.success).toHaveBeenCalledWith("no changes detected");
});
