import { test, expect, vi } from 'vitest';
import { render_release } from './print.js';
import { base_changelog } from './init.js';

test( 'render_release a string', () => {
    const {body} = render_release({})("as is");
    expect(body).toEqual('as is');
});

test( 'render_release', () => {
    const consola = { error: vi.fn() };
    const res= render_release({consola},base_changelog)({
        version: '1.2.3',
        date: 'today',
        changes: [
            "this",
            "that",
        ]
    });
    expect(res.body).toContain('# 1.2.3 today');
    expect(res.body).toContain('* this');
});
