import u from "@yanick/updeep-remeda";
import fs from "fs-extra";
import yaml from "yaml";
import { render_release } from "./print.js";

export async function next_release() {
  const source = await this.changelog();
  return (
    source.releases.find(u.matches({ version: "NEXT" })) ?? {
      version: "NEXT",
      changes: [],
    }
  );
}

const handler = async (config) => {
  const source = await config.changelog();

  const { body } = render_release(
    { ...config, next: true },
    source
  )(await config.next_release());

  config.consola.raw("\n" + body);
};

export default {
  command: "upcoming",
  desc: "output the changes in NEXT",
  handler,
};
