import { test, expect, vi } from "vitest";
import upcoming from "./upcoming.js";

test("basic", async () => {
  const changelog = {
    releases: [{ version: "NEXT", changes: [] }, { version: "1.0.0" }],
    change_types: [],
  };

  const noop = () => {};
  const config = {
    consola: {
      start: noop,
      raw: vi.fn(),
    },
    changelog: () => changelog,
    next_release: () => ({
      changes: [],
    }),
    latest_version: () => ({ version: "1.2.3" }),
    git: () => ({
      log: () => ({ all: [] }),
    }),
  };

  await upcoming.handler(config);

  expect(config.consola.raw).toHaveBeenCalled();
});
